/*
 * mpegav.h
 * Copyright (C) 2006 - 2008 Josh Sutherland.
  * This file is part of VC/DC, a free MPEG-2 video player.
 *
 * VC/DC is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#ifndef MPEGAV_H
#define MPEGAV_H
#include "inttypes.h"
#include "libvcd.h"
int video_play(char * file_to_play);
int vcd_play(_EntriesVcd_sim *entries_list);

void set_audio_quality(int quality);
void set_eq(int setting);
void enable_eq (int enable);

/* This does not handle pausing! It just deals with the
   fact that a pause was triggered, and shuts off audio
   and resets the fps counter. */
void mpegav_pause();			

/* Taken from xine to handle resampling of audio when ahead or behind. Use carefully,
  because it does not preserve pitch! */
void _x_audio_out_resample_stereo(int16_t* input_samples, uint32_t in_samples, 
				  int16_t* output_samples, uint32_t out_samples);
void _x_audio_out_resample_mono(int16_t* input_samples, uint32_t in_samples, 
				  int16_t* output_samples, uint32_t out_samples);
				  
/* Also taken from xine, these should preserve pitch. */
void stretch_mono(int16_t* input_samples, uint32_t in_samples, 
				int16_t* output_samples, uint32_t out_samples);
void stretch_stereo(int16_t* input_samples, uint32_t in_samples, 
				int16_t* output_samples, uint32_t out_samples);
				  
#endif /* MPEGAV_H */
